﻿# -*- coding: utf-8 -*-
"""
neuron.pyプログラム
単体の人工ニューロンの計算  
適当な重みとしきい値を有する人工ニューロンを模擬します
使い方　c:\>python neuron.py < data24.txt
"""
# モジュールのインポート
import math
import sys

# グローバル変数
INPUTNO = 2       #入力数
MAXINPUTNO = 100  #データの最大個数

# 下請け関数の定義
# getdata()関数
def getdata(e):
    """学習データの読み込み"""
    n_of_e = 0   #データセットの個数
    # データの入力
    for line in sys.stdin : 
        e[n_of_e] = [float(num) for num in line.split()]
        n_of_e += 1
    return n_of_e 
# getdata()関数の終わり

# forward()関数
def forward(w,e):
    """順方向の計算"""
    #計算の本体
    u = 0.0
    for i in range(INPUTNO):
        u += e[i] * w[i]
    u -= w[INPUTNO] #しきい値の処理
    #出力値の計算
    o = f(u)
    return o
# forward()関数の終わり

# f()関数
def f(u):
    """伝達関数"""
    #ステップ関数の計算
    if u >= 0:
        return 1.0
    else:
        return 0.0
    #シグモイド関数の計算
#    return 1.0/(1.0+math.exp(-u))
 
# f()関数の終わり

# メイン実行部
w = [1.0,1.0,1.5]        #重みとしきい値
#w = [1.0,1.0,0.5]       #重みとしきい値(他の例)

e = [[0.0 for i in range(INPUTNO)] 
      for j in range(MAXINPUTNO)]       #データセット

#入力データの読み込み
n_of_e = getdata(e)
print("データの個数:",n_of_e)

#計算の本体
for i in range(n_of_e):
    print(i,":",e[i],"->",forward(w,e[i]))
   
# neuron.pyの終わり
