﻿# -*- coding: utf-8 -*-
"""
nn.pyプログラム
単純な階層型ニューラルネットの計算  
 １出力のネットワークを計算します（学習なし）
使い方　c:\>python nn.py < data24.txt
"""
# モジュールのインポート
import math
import sys

# グローバル変数
INPUTNO = 2       #入力数
HIDDENNO = 2      #中間層のセル数
MAXINPUTNO = 100  #データの最大個数

# 下請け関数の定義
# getdata()関数
def getdata(e):
    """学習データの読み込み"""
    n_of_e = 0   #データセットの個数
    # データの入力
    for line in sys.stdin : 
        e[n_of_e] = [float(num) for num in line.split()]
        n_of_e += 1
    return n_of_e 
# getdata()関数の終わり

# forward()関数
def forward(wh,wo,hi,e):
    """順方向の計算"""
    #hiの計算
    for i in range(HIDDENNO):
        u = 0.0
        for j in range(INPUTNO):
            u += e[j] * wh[i][j]
        u -= wh[i][INPUTNO] #しきい値の処理
        hi[i] = f(u)
    #出力oの計算
    o=0.0
    for i in range(HIDDENNO):
        o += hi[i] * wo[i]
    o -= wo[HIDDENNO] #しきい値の処理
    return f(o)
# forward()関数の終わり

# f()関数
def f(u):
    """伝達関数"""
    #ステップ関数の計算
    if u >= 0:
        return 1.0
    else:
        return 0.0
    #シグモイド関数の計算
#    return 1.0/(1.0+math.exp(-u))
 
# f()関数の終わり

# メイン実行部
wh = [[-2,3,-1],[-2,1,0.5]]             #中間層の重み
wo = [-60,94,-1]                        #出力層の重み
e = [[0.0 for i in range(INPUTNO)] 
      for j in range(MAXINPUTNO)]       #データセット
hi = [0 for i in range(HIDDENNO + 1)]   #中間層の出力

#入力データの読み込み
n_of_e = getdata(e)
print("データの個数:",n_of_e)

#計算の本体
for i in range(n_of_e):
    print(i,":",e[i],"->",forward(wh,wo,hi,e[i]))
   
# nn.pyの終わり
